/* $Id: bpfHash.h,v 1.11 2003/03/12 20:16:22 lergnom Exp $ -*- C++ -*-
 * 
 * libbpfl - Bayesian Probability Filtering Library
 * Copyright (C) 2003 Anthony Ventimiglia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
#ifndef BPF_HASH_H
#define BPF_HASH_H

#ifdef __BPF_BUILD
#include "common.h"
#endif 

#include <functional>

namespace bpf {

///This is an abstract base which can be used as the skeleton to the Hash
///Function object used by bpf::Hash<K, V, H>.
///
template <typename KeyType>
struct Hash_base : public std::unary_function<size_t, KeyType>
{
    virtual size_t operator() ( const KeyType& k ) = 0;
};


};				// namespace bpf
#endif // BPF_HASH_H
